<a id="mypy-boto3-fms"></a>

# mypy-boto3-fms

[![PyPI - mypy-boto3-fms](https://img.shields.io/pypi/v/mypy-boto3-fms.svg?color=blue)](https://pypi.org/project/mypy-boto3-fms)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-fms.svg?color=blue)](https://pypi.org/project/mypy-boto3-fms)
[![Docs](https://img.shields.io/readthedocs/boto3-stubs.svg?color=blue)](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_fms/)
[![PyPI - Downloads](https://static.pepy.tech/badge/mypy-boto3-fms)](https://pepy.tech/project/mypy-boto3-fms)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.FMS 1.28.15](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/fms.html#FMS)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.16.2](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-fms docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_fms/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-fms](#mypy-boto3-fms)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `FMS`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `boto3-stubs` for `FMS` service.

```bash
# install with boto3 type annotations
python -m pip install 'boto3-stubs[fms]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'boto3-stubs-lite[fms]'


# standalone installation
python -m pip install mypy-boto3-fms
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y mypy-boto3-fms
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto3-stubs[fms]` in your environment:

```bash
python -m pip install 'boto3-stubs[fms]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `boto3-stubs-lite[fms]` in your environment:

```bash
python -m pip install 'boto3-stubs-lite[fms]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `boto3-stubs` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `boto3-stubs` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[fms]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed `boto3-stubs`

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `boto3-stubs[fms]` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[fms]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto3-stubs[fms]` in your environment:

```bash
python -m pip install 'boto3-stubs[fms]'`
```

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `boto3-stubs[fms]` in your environment:

```bash
python -m pip install 'boto3-stubs[fms]'
```

Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`FMSClient` provides annotations for `boto3.client("fms")`.

```python
from boto3.session import Session

from mypy_boto3_fms import FMSClient

client: FMSClient = Session().client("fms")

# now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_fms.paginator` module contains type annotations for all paginators.

```python
from boto3.session import Session

from mypy_boto3_fms import FMSClient
from mypy_boto3_fms.paginator import (
    ListAdminAccountsForOrganizationPaginator,
    ListAdminsManagingAccountPaginator,
    ListAppsListsPaginator,
    ListComplianceStatusPaginator,
    ListMemberAccountsPaginator,
    ListPoliciesPaginator,
    ListProtocolsListsPaginator,
    ListThirdPartyFirewallFirewallPoliciesPaginator,
)

client: FMSClient = Session().client("fms")

# Explicit type annotations are optional here
# Types should be correctly discovered by mypy and IDEs
list_admin_accounts_for_organization_paginator: ListAdminAccountsForOrganizationPaginator = (
    client.get_paginator("list_admin_accounts_for_organization")
)
list_admins_managing_account_paginator: ListAdminsManagingAccountPaginator = client.get_paginator(
    "list_admins_managing_account"
)
list_apps_lists_paginator: ListAppsListsPaginator = client.get_paginator("list_apps_lists")
list_compliance_status_paginator: ListComplianceStatusPaginator = client.get_paginator(
    "list_compliance_status"
)
list_member_accounts_paginator: ListMemberAccountsPaginator = client.get_paginator(
    "list_member_accounts"
)
list_policies_paginator: ListPoliciesPaginator = client.get_paginator("list_policies")
list_protocols_lists_paginator: ListProtocolsListsPaginator = client.get_paginator(
    "list_protocols_lists"
)
list_third_party_firewall_firewall_policies_paginator: ListThirdPartyFirewallFirewallPoliciesPaginator = client.get_paginator(
    "list_third_party_firewall_firewall_policies"
)
```

<a id="literals"></a>

### Literals

`mypy_boto3_fms.literals` module contains literals extracted from shapes that
can be used in user code for type checking.

```python
from mypy_boto3_fms.literals import (
    AccountRoleStatusType,
    CustomerPolicyScopeIdTypeType,
    CustomerPolicyStatusType,
    DependentServiceNameType,
    DestinationTypeType,
    FailedItemReasonType,
    FirewallDeploymentModelType,
    ListAdminAccountsForOrganizationPaginatorName,
    ListAdminsManagingAccountPaginatorName,
    ListAppsListsPaginatorName,
    ListComplianceStatusPaginatorName,
    ListMemberAccountsPaginatorName,
    ListPoliciesPaginatorName,
    ListProtocolsListsPaginatorName,
    ListThirdPartyFirewallFirewallPoliciesPaginatorName,
    MarketplaceSubscriptionOnboardingStatusType,
    NetworkFirewallOverrideActionType,
    OrganizationStatusType,
    PolicyComplianceStatusTypeType,
    RemediationActionTypeType,
    ResourceSetStatusType,
    RuleOrderType,
    SecurityServiceTypeType,
    TargetTypeType,
    ThirdPartyFirewallAssociationStatusType,
    ThirdPartyFirewallType,
    ViolationReasonType,
    FMSServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    RegionName,
)


def check_value(value: AccountRoleStatusType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_fms.type_defs` module contains structures and shapes assembled to
typed dictionaries for additional type checking.

```python
from mypy_boto3_fms.type_defs import (
    AccountScopeOutputTypeDef,
    AccountScopeTypeDef,
    ActionTargetTypeDef,
    AdminAccountSummaryTypeDef,
    OrganizationalUnitScopeOutputTypeDef,
    PolicyTypeScopeOutputTypeDef,
    RegionScopeOutputTypeDef,
    OrganizationalUnitScopeTypeDef,
    PolicyTypeScopeTypeDef,
    RegionScopeTypeDef,
    AppTypeDef,
    AssociateAdminAccountRequestRequestTypeDef,
    AssociateThirdPartyFirewallRequestRequestTypeDef,
    ResponseMetadataTypeDef,
    AwsEc2NetworkInterfaceViolationTypeDef,
    PartialMatchTypeDef,
    BatchAssociateResourceRequestRequestTypeDef,
    FailedItemTypeDef,
    BatchDisassociateResourceRequestRequestTypeDef,
    ComplianceViolatorTypeDef,
    DeleteAppsListRequestRequestTypeDef,
    DeletePolicyRequestRequestTypeDef,
    DeleteProtocolsListRequestRequestTypeDef,
    DeleteResourceSetRequestRequestTypeDef,
    DisassociateThirdPartyFirewallRequestRequestTypeDef,
    DiscoveredResourceTypeDef,
    DnsDuplicateRuleGroupViolationTypeDef,
    DnsRuleGroupLimitExceededViolationTypeDef,
    DnsRuleGroupPriorityConflictViolationTypeDef,
    EvaluationResultTypeDef,
    ExpectedRouteTypeDef,
    FMSPolicyUpdateFirewallCreationConfigActionTypeDef,
    FirewallSubnetIsOutOfScopeViolationTypeDef,
    FirewallSubnetMissingVPCEndpointViolationTypeDef,
    GetAdminScopeRequestRequestTypeDef,
    GetAppsListRequestRequestTypeDef,
    GetComplianceDetailRequestRequestTypeDef,
    GetPolicyRequestRequestTypeDef,
    GetProtectionStatusRequestRequestTypeDef,
    GetProtocolsListRequestRequestTypeDef,
    ProtocolsListDataOutputTypeDef,
    GetResourceSetRequestRequestTypeDef,
    ResourceSetOutputTypeDef,
    GetThirdPartyFirewallAssociationStatusRequestRequestTypeDef,
    GetViolationDetailsRequestRequestTypeDef,
    PaginatorConfigTypeDef,
    ListAdminAccountsForOrganizationRequestRequestTypeDef,
    ListAdminsManagingAccountRequestRequestTypeDef,
    ListAppsListsRequestRequestTypeDef,
    ListComplianceStatusRequestRequestTypeDef,
    ListDiscoveredResourcesRequestRequestTypeDef,
    ListMemberAccountsRequestRequestTypeDef,
    ListPoliciesRequestRequestTypeDef,
    PolicySummaryTypeDef,
    ListProtocolsListsRequestRequestTypeDef,
    ProtocolsListDataSummaryTypeDef,
    ListResourceSetResourcesRequestRequestTypeDef,
    ResourceTypeDef,
    ListResourceSetsRequestRequestTypeDef,
    ResourceSetSummaryTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    TagTypeDef,
    ListThirdPartyFirewallFirewallPoliciesRequestRequestTypeDef,
    ThirdPartyFirewallFirewallPolicyTypeDef,
    RouteTypeDef,
    NetworkFirewallMissingExpectedRTViolationTypeDef,
    NetworkFirewallMissingFirewallViolationTypeDef,
    NetworkFirewallMissingSubnetViolationTypeDef,
    StatefulEngineOptionsTypeDef,
    StatelessRuleGroupTypeDef,
    NetworkFirewallPolicyTypeDef,
    NetworkFirewallStatefulRuleGroupOverrideTypeDef,
    ThirdPartyFirewallPolicyTypeDef,
    ResourceTagTypeDef,
    ProtocolsListDataTypeDef,
    PutNotificationChannelRequestRequestTypeDef,
    ResourceSetTypeDef,
    ThirdPartyFirewallMissingExpectedRouteTableViolationTypeDef,
    ThirdPartyFirewallMissingFirewallViolationTypeDef,
    ThirdPartyFirewallMissingSubnetViolationTypeDef,
    SecurityGroupRuleDescriptionTypeDef,
    UntagResourceRequestRequestTypeDef,
    EC2AssociateRouteTableActionTypeDef,
    EC2CopyRouteTableActionTypeDef,
    EC2CreateRouteActionTypeDef,
    EC2CreateRouteTableActionTypeDef,
    EC2DeleteRouteActionTypeDef,
    EC2ReplaceRouteActionTypeDef,
    EC2ReplaceRouteTableAssociationActionTypeDef,
    AdminScopeOutputTypeDef,
    AdminScopeTypeDef,
    AppsListDataOutputTypeDef,
    AppsListDataSummaryTypeDef,
    AppsListDataTypeDef,
    AssociateThirdPartyFirewallResponseTypeDef,
    DisassociateThirdPartyFirewallResponseTypeDef,
    EmptyResponseMetadataTypeDef,
    GetAdminAccountResponseTypeDef,
    GetNotificationChannelResponseTypeDef,
    GetProtectionStatusResponseTypeDef,
    GetThirdPartyFirewallAssociationStatusResponseTypeDef,
    ListAdminAccountsForOrganizationResponseTypeDef,
    ListAdminsManagingAccountResponseTypeDef,
    ListMemberAccountsResponseTypeDef,
    AwsEc2InstanceViolationTypeDef,
    BatchAssociateResourceResponseTypeDef,
    BatchDisassociateResourceResponseTypeDef,
    PolicyComplianceDetailTypeDef,
    ListDiscoveredResourcesResponseTypeDef,
    PolicyComplianceStatusTypeDef,
    NetworkFirewallMissingExpectedRoutesViolationTypeDef,
    GetProtocolsListResponseTypeDef,
    PutProtocolsListResponseTypeDef,
    GetResourceSetResponseTypeDef,
    PutResourceSetResponseTypeDef,
    ListAdminAccountsForOrganizationRequestListAdminAccountsForOrganizationPaginateTypeDef,
    ListAdminsManagingAccountRequestListAdminsManagingAccountPaginateTypeDef,
    ListAppsListsRequestListAppsListsPaginateTypeDef,
    ListComplianceStatusRequestListComplianceStatusPaginateTypeDef,
    ListMemberAccountsRequestListMemberAccountsPaginateTypeDef,
    ListPoliciesRequestListPoliciesPaginateTypeDef,
    ListProtocolsListsRequestListProtocolsListsPaginateTypeDef,
    ListThirdPartyFirewallFirewallPoliciesRequestListThirdPartyFirewallFirewallPoliciesPaginateTypeDef,
    ListPoliciesResponseTypeDef,
    ListProtocolsListsResponseTypeDef,
    ListResourceSetResourcesResponseTypeDef,
    ListResourceSetsResponseTypeDef,
    ListTagsForResourceResponseTypeDef,
    TagResourceRequestRequestTypeDef,
    ListThirdPartyFirewallFirewallPoliciesResponseTypeDef,
    NetworkFirewallBlackHoleRouteDetectedViolationTypeDef,
    NetworkFirewallInternetTrafficNotInspectedViolationTypeDef,
    NetworkFirewallInvalidRouteConfigurationViolationTypeDef,
    NetworkFirewallUnexpectedFirewallRoutesViolationTypeDef,
    NetworkFirewallUnexpectedGatewayRoutesViolationTypeDef,
    RouteHasOutOfScopeEndpointViolationTypeDef,
    StatefulRuleGroupTypeDef,
    PolicyOptionTypeDef,
    PutProtocolsListRequestRequestTypeDef,
    PutResourceSetRequestRequestTypeDef,
    SecurityGroupRemediationActionTypeDef,
    RemediationActionTypeDef,
    GetAdminScopeResponseTypeDef,
    PutAdminAccountRequestRequestTypeDef,
    GetAppsListResponseTypeDef,
    PutAppsListResponseTypeDef,
    ListAppsListsResponseTypeDef,
    PutAppsListRequestRequestTypeDef,
    GetComplianceDetailResponseTypeDef,
    ListComplianceStatusResponseTypeDef,
    NetworkFirewallPolicyDescriptionTypeDef,
    SecurityServicePolicyDataTypeDef,
    AwsVPCSecurityGroupViolationTypeDef,
    RemediationActionWithOrderTypeDef,
    NetworkFirewallPolicyModifiedViolationTypeDef,
    PolicyOutputTypeDef,
    PolicyTypeDef,
    PossibleRemediationActionTypeDef,
    GetPolicyResponseTypeDef,
    PutPolicyResponseTypeDef,
    PutPolicyRequestRequestTypeDef,
    PossibleRemediationActionsTypeDef,
    ResourceViolationTypeDef,
    ViolationDetailTypeDef,
    GetViolationDetailsResponseTypeDef,
)


def get_structure() -> AccountScopeOutputTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for `boto3`
updates. It delivers drop-in type annotations for you and makes sure that:

- All available `boto3` services are covered.
- Each public class and method of every `boto3` service gets valid type
  annotations extracted from `botocore` schemas.
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore`, `aiobotocore` and `aioboto3`
  libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.resource` calls
- Auto discovery of types for `session.client` and `session.resource` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`mypy-boto3-fms` version is the same as related `boto3` version and follows
[PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[boto3 docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_fms/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
